542. 01 Matrix [LeetCode]

本文介绍了一种高效算法来解决矩阵中每个元素到最近零元素的距离问题。通过使用广度优先搜索(BFS)策略,并从所有零元素开始遍历,确保了每次更新的距离是最短的。最终实现了O(m*n)的时间复杂度。

摘要生成于 C知道 ,由 DeepSeek-R1 满血版支持, 前往体验 >

Given a matrix consists of 0 and 1, find the distance of the nearest 0 for each cell.

The distance between two adjacent cells is 1.

Example 1: 
Input:

0 0 0
0 1 0
0 0 0
Output:
0 0 0
0 1 0
0 0 0

Example 2: 
Input:

0 0 0
0 1 0
1 1 1
Output:
0 0 0
0 1 0
1 2 1

Note:

  1. The number of elements of the given matrix will not exceed 10,000.
  2. There are at least one 0 in the given matrix.
  3. The cells are adjacent in only four directions: up, down, left and right.

题目大意:这题给我们一个0-1矩阵,要我们求出矩阵中每个元素,到最近的0的距离。


思路概述:因为0元素最后的返回值还是0,要求元素1到最近的0的距离,首先就想到BFS。首先,我从每一个1开始向周围BFS,直到找到最近的0,但这样做的时间复杂度过高,提交结果TLE,没有能够通过。
之后在LeetCode的讨论区学习了一下,发现思路没有什么问题,只是BFS遍历时可以优化一下:遍历原数组,将1都置为Max_Value。建立一个队列,加入所有0元素的位置;之后从队列中的元素出发遍历周边元素,如果其周边的元素不越界且大于元素值+1,更新其值为当前中心元素值+1,将这个周边元素加到队列中,构成下一层节点。


AC代码如下:

public class Solution {
    public int[][] updateMatrix(int[][] matrix) {
        int m = matrix.length;
        int n = matrix[0].length;
        
        if (m==0 || n==0 || matrix==null)
            return null;
        
        Queue<int[]> queue = new LinkedList<>();
        for (int i=0; i<m; i++) {
            for (int j=0; j<n; j++) {
                if (matrix[i][j] == 0) {
                    queue.offer(new int[] {i, j});
                } else {
                    matrix[i][j] = Integer.MAX_VALUE;
                }
            }
        }
        
        int[][] dirs = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}};
        while (!queue.isEmpty()) {
            int[] cell = queue.poll();
            for (int[] dir : dirs) {
                int x = cell[0] + dir[0];
                int y = cell[1] + dir[1];
                if (x<0 || x>=m || y<0 || y>=n || matrix[x][y] <= matrix[cell[0]][cell[1]]+1)
                    continue;
                queue.offer(new int[] {x, y});
                matrix[x][y] = matrix[cell[0]][cell[1]] + 1;
            }
        }
        
        return matrix;
    }
}


LeetCode 542题是要求实现一个算法,将一个给定的二维数组(0代表墙,1代表空地,2代表细菌)按以下规则进行更新: - 任何1都会被更新为2; - 每个1旁边的空地(与1在上下左右相邻),会按顺序变为1; - 根据更新规则,墙(0)不变。 这个问题可以用广度优先搜索(BFS)解决。我们可以从所有初始为2的细菌开始,将其周围的空地依次更新为1。我们从这些初始的细菌出发,将它们的相邻位置放入队列中,然后不断从队列中取出位置进行更新,直到队列为空。 以下是一个可能的C++解决方案: ```cpp #include <vector> using namespace std; class Solution { public: vector<vector<int>> updateMatrix(vector<vector<int>>& matrix) { int m = matrix.size(), n = matrix[0].size(); vector<vector<int>> dirs = {{1, 0}, {-1, 0}, {0, 1}, {0, -1}}; vector<vector<int>> ans(m, vector<int>(n, INT_MAX)); queue<pair<int, int>> q; // 初始化,将所有的细菌位置加入队列,并记录答案中的距离 for (int i = 0; i < m; ++i) { for (int j = 0; j < n; ++j) { if (matrix[i][j] == 2) { q.push({i, j}); ans[i][j] = 0; } } } // 广度优先搜索 while (!q.empty()) { auto [x, y] = q.front(); q.pop(); for (auto& dir : dirs) { int nx = x + dir[0], ny = y + dir[1]; if (nx >= 0 && nx < m && ny >= 0 && ny < n && ans[nx][ny] > ans[x][y] + 1) { ans[nx][ny] = ans[x][y] + 1; q.push({nx, ny}); } } } return ans; } }; ``` 在这段代码中,首先创建了一个方向数组`dirs`来表示上下左右四个方向。接着,初始化一个同样大小的二维数组`ans`来存储每个位置到最近细菌的距离,并将所有的细菌位置和初始距离0加入队列中。然后执行广度优先搜索,对于队列中的每个位置,将其相邻的空地加入队列,并更新`ans`数组中相应位置的值为当前位置到最近细菌的最短距离。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值